/* NiuTrans.Tensor - an open-source tensor library
* Copyright (C) 2017, Natural Language Processing Lab, Northestern University.
* All rights reserved.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*   http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

/*
* $Created by: ZHANG Yuhao (email: zhangyuhao@stu.neu.edu.cn) 2019-07-23
*/

//#include <cstring>
#include <math.h>
#include "../../XGlobal.h"

namespace nts {
class VectorBuffer {
private:
    /* buffer for concluter */
    DTYPE values[32 / sizeof(DTYPE)] = { 0 };
public:
    /* data size for each buffer */
    static int size();

    /* constructor */
    VectorBuffer();

    /* constructor */
    VectorBuffer(DTYPE val);

    /* load data */
    static VectorBuffer loadu(const DTYPE* ptr, bool isExp = false, DTYPE power = (DTYPE)1.0F, DTYPE* bias = NULL); 

    /* overloading [] */
    const DTYPE& operator[](int idx)const; 

    /* overloading + */
    VectorBuffer operator+(const VectorBuffer &a); 

    /* conculte the max of two buffer */
    VectorBuffer maxData(const VectorBuffer &a); 
};
}