/* NiuTrans.Tensor - an open-source tensor library
 * Copyright (C) 2017, Natural Language Processing Lab, Northestern University. 
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 * $Created by: Xu Chen (email: hello_master1954@163.com) 2019-06-12
 */

#ifndef __SOFTMAXWITHCROSSENTROPY_H__
#define __SOFTMAXWITHCROSSENTROPY_H__

#include "../XTensor.h"

namespace nts{ // namespace nts(NiuTrans.Tensor)

/* softmax functoin and cross entropy */
void _SoftmaxWithCrossEntropy(const XTensor * x, XTensor * y, const XTensor * gold, DTYPE labelSmoothingP = 0, int leadDim = -1);

/* softmax function and cross entropy (return an XTensor structure) */
XTensor SoftmaxWithCrossEntropy(const XTensor & x, const XTensor & gold, DTYPE labelSmoothingP = 0, int leadDim = -1);

/* de/dx */
void _SoftmaxWithCrossEntropyBackward(XTensor * gold, XTensor * y, XTensor * x, 
                      XTensor * dedy, XTensor * dedx,
                      XTensor * padding, int leadDim);

} // namespace nts(NiuTrans.Tensor)

#endif // __SOFTMAXWITHCROSSENTROPY_H__